
#include <acknex.h>
#include <default.c>
#include <windows.h>
#include <d3d9.h>
#include <com.h>
#include <litec.h>

#define PRAGMA_ZERO

char szFile[MAX_PATH];

STRING* tstr = "";

FONT* veranda_font = "veranda#20";

STRING* font_name = "veranda";
var font_sz = 20;

STRING* date = "#64";

BMAP* background;
PANEL* pan_background;

var font_color[3];
var bk_color[3]; //background_color

TEXT* main_text = 
{
	font = veranda_font;
	strings = 10;
	flags = VISIBLE;
}

TEXT* ai_text = 
{
	pos_x = 400;
	font = veranda_font;
	strings = 10;
	flags = VISIBLE;
}

var i;
var fhandle;

void reset_strings(TEXT* ttext)
{
	for(i=0; i<=9; i ++){str_cpy((ttext.pstring)[i],"#64");}
}

void swap_text(TEXT* ttext,STRING* stra)
{
	if(stra != NULL){str_cpy((ttext.pstring)[9],stra);}
	
	fhandle = file_open_append(date);
	
	if(ttext == main_text){file_str_write(fhandle,"player say: ");}
	if(ttext == ai_text){file_str_write(fhandle,"ai say: ");}
	
	file_str_write(fhandle,(ttext.pstring)[9]);
	file_str_write(fhandle,"
");

	file_close(fhandle);
	
	for(i=0; i<=8; i ++){str_cpy((ttext.pstring)[i],(ttext.pstring)[i+1]);}
	str_cpy((ttext.pstring)[9],"#64");
}

function create_file()
{
	str_cpy(date,"");
	str_cat_num(date,"log/speech%.0f",sys_hours);
	str_cat_num(date,"_%.0f",sys_minutes);
	str_cat_num(date,"-%.0f",sys_day);
	str_cat_num(date,"_%.0f",sys_month);
	str_cat_num(date,"_%00.f.txt",sys_year-2000);
}

void save_all_data(STRING* file_name)
{
	wait(1);
	fhandle = file_open_write(file_name);
	
	//font
	file_str_write(fhandle,font_name);
	file_str_write(fhandle," ");
	file_var_write(fhandle,font_sz);
	file_str_write(fhandle,"
");

	//font color
	file_var_write(fhandle,font_color[0]);
	file_var_write(fhandle,font_color[1]);
	file_var_write(fhandle,font_color[2]);
	file_str_write(fhandle,"
");

	//background
	file_var_write(fhandle,bk_color[0]);
	file_var_write(fhandle,bk_color[1]);
	file_var_write(fhandle,bk_color[2]);
	file_str_write(fhandle,"
");
	//bmap background location
	file_str_write(fhandle,_str(szFile));
	file_str_write(fhandle,"
");
	file_close(fhandle);
}

void load_data(STRING* file_name)
{
	fhandle = file_open_write(file_name);
	
	//font
	file_str_read(fhandle,font_name);
	font_sz = file_var_read(fhandle);
	
	str_cpy(font_name,(main_text.pstring)[9]);
	str_cpy(tstr,font_name);
	str_cat(tstr,"#");
	str_cat_num(tstr,"%.0f",font_sz);
	veranda_font = font_create(tstr);
	main_text.font = veranda_font;
	ai_text.font = veranda_font;

	//font color
	font_color[0] = file_var_read(fhandle);
	font_color[1]	= file_var_read(fhandle);
	font_color[2] = file_var_read(fhandle);
	vec_set(main_text.blue,font_color[0]);
	vec_set(ai_text.blue,font_color[0]);

	//background color
	bk_color[0] = file_var_read(fhandle);
	bk_color[1] = file_var_read(fhandle);
	bk_color[2] = file_var_read(fhandle);
	vec_set(screen_color.blue,bk_color[0]);
	
	file_str_read(fhandle,tstr);
	background = bmap_create("D:\\Gamestudio projects\\speech\\screen.bmp");
		pan_background = pan_create(tstr,0);
		set(pan_background,VISIBLE);
		pan_background.bmap = background;
		pan_background.scale_x = screen_size.x / bmap_width(background);
		pan_background.scale_y = screen_size.y / bmap_height(background);
	
	file_close(fhandle);
}

function open_load_data()
{
	ZeroMemory(szFile, MAX_PATH);
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize	= sizeof(OPENFILENAME);
	ofn.Flags		= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR;
	ofn.lpstrFilter	= ".txt\0*.txt\0All\0*.*\0";
	ofn.lpstrTitle	= "Open";
	ofn.lpstrFile	= szFile;
	ofn.nMaxFile	= MAX_PATH;
	
	if ( GetOpenFileName(&ofn) )
	{
		swap_text(ai_text,_str(szFile));
		load_data(_str(szFile));
	}
}

function open_a()
{
	ZeroMemory(szFile, MAX_PATH);
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize	= sizeof(OPENFILENAME);
	ofn.Flags		= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR;
	ofn.lpstrFilter	= ".BMP\0*.BMP\0All\0*.*\0";
	ofn.lpstrTitle	= "Open";
	ofn.lpstrFile	= szFile;
	ofn.nMaxFile	= MAX_PATH;
	
	if ( GetOpenFileName(&ofn) )
	{
		swap_text(ai_text,_str(szFile));
		background = bmap_create("D:\\Gamestudio projects\\speech\\screen.bmp");
		pan_background = pan_create(_str(szFile),0);
		set(pan_background,VISIBLE);
		pan_background.bmap = background;
		pan_background.scale_x = screen_size.x / bmap_width(background);
		pan_background.scale_y = screen_size.y / bmap_height(background);
	}
}

function save_a()
{
	ZeroMemory(szFile, MAX_PATH);
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize	= sizeof(OPENFILENAME);
	ofn.Flags		= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_OVERWRITEPROMPT;
	ofn.lpstrFilter	= ".txt\0*.txt\0All\0*.*\0";
	ofn.lpstrTitle	= "save as...";
	ofn.lpstrFile	= szFile;
	ofn.nMaxFile	= MAX_PATH;
	
	if ( GetSaveFileName(&ofn) )
	{
		save_all_data(_str(szFile));
	}
}

function main()
{
	wait(1);
	
	vec_set(screen_color,vector(0,0,1));
	reset_strings(main_text);
	reset_strings(ai_text);
	
	var new_color[3];
	
	create_file();
	
	swap_text(ai_text,"welcom to flits speech");
	
	while(1)
	{
		result = inkey((main_text.pstring)[9]);
		
		//dialog
		//-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->
		
		//hello
		if(str_cmpi((main_text.pstring)[9],"hello") || str_cmpi((main_text.pstring)[9],"hey")){swap_text(ai_text,"hello");}
		
		//by
		if(str_cmpi((main_text.pstring)[9],"by")){swap_text(ai_text,"by");}
		
		
		//commands
		//-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->-->
		
		//quit
		if(str_cmpi((main_text.pstring)[9],"_exit") || str_cmpi((main_text.pstring)[9],"_quit")){sys_exit("");}
		
		//text color
		if(str_cmpi((main_text.pstring)[9],"_tcolor"))
		{
			swap_text(ai_text,"enter blue 0-255");
			
			swap_text(main_text,NULL);
			inkey((main_text.pstring)[9]);
			
			new_color[0] = str_to_num((main_text.pstring)[9]);
			swap_text(ai_text,"enter green 0-255");
			
			swap_text(main_text,NULL);
			inkey((main_text.pstring)[9]);
			
			new_color[1] = str_to_num((main_text.pstring)[9]);
			swap_text(ai_text,"enter red 0-255");
			
			swap_text(main_text,NULL);
			inkey((main_text.pstring)[9]);
			
			new_color[2] = str_to_num((main_text.pstring)[9]);
			
			vec_set(main_text.blue,new_color[0]);
			vec_set(ai_text.blue,new_color[0]);
			vec_set(font_color[0],new_color[0]);
			
			swap_text(ai_text,"text color changed");
		}
		
		//backrground collor
		if(str_cmpi((main_text.pstring)[9],"_bcolor"))
		{
			swap_text(ai_text,"enter blue 0-255");
			
			swap_text(main_text,NULL);
			inkey((main_text.pstring)[9]);
			
			new_color[0] = str_to_num((main_text.pstring)[9]);
			swap_text(ai_text,"enter green 0-255");
			
			swap_text(main_text,NULL);
			inkey((main_text.pstring)[9]);
			
			new_color[1] = str_to_num((main_text.pstring)[9]);
			swap_text(ai_text,"enter red 0-255");
			
			swap_text(main_text,NULL);
			inkey((main_text.pstring)[9]);
			
			new_color[2] = str_to_num((main_text.pstring)[9]);
			
			vec_set(screen_color.blue,new_color[0]);
			vec_set(bk_color[0],new_color[0]);
			
			swap_text(ai_text,"backgroundcolor changed");
		}
		
		//font size
		if(str_cmpi((main_text.pstring)[9],"_szfont"))
		{
			swap_text(ai_text,"enter size 1-30");
			
			swap_text(main_text,NULL);
			inkey((main_text.pstring)[9]);
			
			font_sz = str_to_num((main_text.pstring)[9]);
			font_sz = clamp(font_sz,1,30);
			str_cpy(tstr,font_name);
			str_cat(tstr,"#");
			str_cat_num(tstr,"%.0f",font_sz);
			
			veranda_font = font_create(tstr);
			
			main_text.font = veranda_font;
			ai_text.font = veranda_font;
			
			swap_text(ai_text,"font size changed");
		}
		
		if(str_cmpi((main_text.pstring)[9],"_namefont"))
		{
			swap_text(ai_text,"enter font name");
			
			swap_text(main_text,NULL);
			inkey((main_text.pstring)[9]);
			
			str_cpy(font_name,(main_text.pstring)[9]);
			str_cpy(tstr,font_name);
			str_cat(tstr,"#");
			str_cat_num(tstr,"%.0f",font_sz);
			
			veranda_font = font_create(tstr);
			
			main_text.font = veranda_font;
			ai_text.font = veranda_font;
			
			swap_text(ai_text,"font name changed");
		}
		
		//-->--> save/load
		
		//save data
		if(str_cmpi((main_text.pstring)[9],"_save"))
		{
			save_all_data("data.txt");
			swap_text(ai_text,"saved");
		}
		//save data as
		if(str_cmpi((main_text.pstring)[9],"_saveas"))
		{
			save_a();
			swap_text(ai_text,"saved");
		}
		//load data as
		if(str_cmpi((main_text.pstring)[9],"_load"))
		{
			open_load_data();
			swap_text(ai_text,"load");
		}
		
		//-->-->START GAMES
		
		//start minesweeper
		if(str_cmpi((main_text.pstring)[9],"_mine"))
		{
			if(exec("C:\\WINDOWS\\system32\\winmine.exe","")){swap_text(ai_text,"minesweeper started");}
		}
		
		//start PINBAL
		if(str_cmpi((main_text.pstring)[9],"_pin"))
		{
			if(exec("C:\\Program Files\\Windows NT\\Pinball\\PINBALL.EXE","")){swap_text(ai_text,"pinbal started");}
		}
		
		//start freecell
		if(str_cmpi((main_text.pstring)[9],"_freecell"))
		{
			if(exec("C:\\WINDOWS\\system32\\freecell.exe","")){swap_text(ai_text,"freecell started");}
		}
		
		//start solitaire
		if(str_cmpi((main_text.pstring)[9],"_sol"))
		{
			if(exec("C:\\WINDOWS\\system32\\sol.exe","")){swap_text(ai_text,"solitaire started");}
		}
		
		//start spider solitaire
		if(str_cmpi((main_text.pstring)[9],"_ssol"))
		{
			if(exec("C:\\WINDOWS\\system32\\spider.exe","")){swap_text(ai_text,"spider solitaire started");}
		}
		
		//internet explorer
		if(str_cmpi((main_text.pstring)[9],"_ie"))
		{
			swap_text(ai_text,"enter website");
			
			swap_text(main_text,NULL);
			inkey((main_text.pstring)[9]);
			
		if(exec("C:\\program files\\internet explorer\\iexplore.exe",(main_text.pstring)[9])){swap_text(ai_text,"website started");}
		}
		
		
		//set background
		if(str_cmpi((main_text.pstring)[9],"_setb")){open_a();}
		
		//commandlist
		if(str_cmpi((main_text.pstring)[9],"help") ||
			str_cmpi((main_text.pstring)[9],"_help") ||
			str_cmpi((main_text.pstring)[9],"_commandlist"))
		{
			swap_text(ai_text,"_bcolor = backgroundcolor");
			swap_text(ai_text,"_tcolor = textcolor");
			swap_text(ai_text,"_exit/_quit = exit/quit");
			swap_text(ai_text,"_namefont = font name");
			swap_text(ai_text,"_szfont = font size");
			swap_text(ai_text,"_setb = set background bmap");
			swap_text(ai_text,"_save = save all data");
			swap_text(ai_text,"_saveas = save all data as");
		}
		
		swap_text(main_text,NULL);
		if(27 == result){sys_exit("");}
		wait(1);
	}
}
